// Alias.cs -- demonstrates using an alias to resolve ambiguity
//
//             Compile this program with the following command line:
//                 C:>csc Alias.cs
using System;
using MsgBox = System.Windows.Forms.MessageBox;
using System.Timers;

namespace nsNamespaces
{
    class clsMain
    {
        static Timer timer;
        static public void Main ()
        {
// Create the timer object.
            timer = new Timer (2000);
// This is a one-shot timer. Set auto reset to false
            timer.AutoReset = false;
// Assign the event handler method.
            timer.Elapsed += new ElapsedEventHandler(ProcessTimerEvent);
// Start the timer.
            timer.Start ();
// Wait for the timeout to occur.
            MsgBox.Show ("Waiting for timer to expire", "Text");
        }

// Timer event handler.
        private static void ProcessTimerEvent (Object obj, ElapsedEventArgs e)
        {
            MsgBox.Show ("The timer has expired. Press \"OK\" " +
                         " to terminate the program",
                         "Timer Expired");
            timer.Close ();
            Environment.Exit (0);
        }
    }
}
