// AppLog.cs -- Demonstrates registering and event source and writing to the
//              Application Log.
//
//              Compile this program with the following command line:
//                  C:>csc AppLog
using System;
using System.Diagnostics;
using System.IO;

namespace nsEventLogs
{
    class clsMain
    {
        static public void Main ()
        {
// Create the EventLog object
            EventLog EvLog = new EventLog ();
// Register the source if it has not already been registered
            if (!EventLog.SourceExists ("AppLog.exe"))
            {
                Console.WriteLine ("Creating event log source");
                EventLog.CreateEventSource ("AppLog.exe", "Application");
            }
// Set the source for the messages to be display in the Event Viewer
            EvLog.Source = "AppLog.exe";
// Throw an exception. You don't have to do this, but it's a good reason to
// write to the log.
            try
            {
                CauseTrouble ();
            }
            catch (IOException)
            {
// Write the information to the application log
                EvLog.WriteEntry("IO exception was thrown", EventLogEntryType.Warning);
            }
        }
        static void CauseTrouble ()
        {
            throw (new IOException());
        }
    }
}
