using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

namespace List
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ListView listView1;
		private System.Windows.Forms.ImageList imgLargeIcon;
		private System.Windows.Forms.ImageList imgSmallIcon;
		private System.Windows.Forms.ImageList imgToolbar;
		private System.Windows.Forms.ToolBarButton tbLargeIcon;
		private System.Windows.Forms.ToolBarButton tbSmallIcon;
		private System.Windows.Forms.ToolBarButton tbList;
		private System.Windows.Forms.ToolBarButton tbReport;
		private System.Windows.Forms.ColumnHeader lvcState;
		private System.Windows.Forms.ColumnHeader lvcCapital;
		private System.ComponentModel.IContainer components;

		//
		// Instance fields.
		clsSort Sorter = new clsSort();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			int index = 0;
// Read the data file.
			FileStream strm;
			try
			{
				strm = new FileStream ("States.txt", FileMode.Open, FileAccess.Read);
				StreamReader reader = new StreamReader (strm);
				while (reader.Peek() > 0)
				{
// Split the string using the comma as a field separator.
					string State = reader.ReadLine();
					string [] Data = State.Split (new char [] {','});
// Create a ListViewItem to hold the data.
					ListViewItem item = new ListViewItem (Data);
// The data file is in alphabetical order. If you added the flag images
// to the image list alphabetically, you can just use the index value.
					item.ImageIndex = index++;
// Add the item to the control.
					listView1.Items.Add (item);
				}
				strm.Close ();
			}
			catch (FileNotFoundException)
			{
				MessageBox.Show ("Cannot open file", "Warning");
			}
// Assign the clsSort object to the item sorter.
			listView1.ListViewItemSorter = Sorter;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.tbSmallIcon = new System.Windows.Forms.ToolBarButton();
			this.tbList = new System.Windows.Forms.ToolBarButton();
			this.tbReport = new System.Windows.Forms.ToolBarButton();
			this.listView1 = new System.Windows.Forms.ListView();
			this.lvcState = new System.Windows.Forms.ColumnHeader();
			this.lvcCapital = new System.Windows.Forms.ColumnHeader();
			this.imgLargeIcon = new System.Windows.Forms.ImageList(this.components);
			this.imgSmallIcon = new System.Windows.Forms.ImageList(this.components);
			this.label1 = new System.Windows.Forms.Label();
			this.imgToolbar = new System.Windows.Forms.ImageList(this.components);
			this.tbLargeIcon = new System.Windows.Forms.ToolBarButton();
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// tbSmallIcon
			// 
			this.tbSmallIcon.ImageIndex = 1;
			this.tbSmallIcon.Text = "Small Icon";
			this.tbSmallIcon.ToolTipText = "Display items with small icons";
			// 
			// tbList
			// 
			this.tbList.ImageIndex = 2;
			this.tbList.Text = "List";
			this.tbList.ToolTipText = "Display items in list mode";
			// 
			// tbReport
			// 
			this.tbReport.ImageIndex = 3;
			this.tbReport.Text = "Report";
			this.tbReport.ToolTipText = "Display items in report (detail) mode";
			// 
			// listView1
			// 
			this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						this.lvcState,
																						this.lvcCapital});
			this.listView1.FullRowSelect = true;
			this.listView1.LargeImageList = this.imgLargeIcon;
			this.listView1.Location = new System.Drawing.Point(0, 32);
			this.listView1.MultiSelect = false;
			this.listView1.Name = "listView1";
			this.listView1.Size = new System.Drawing.Size(292, 160);
			this.listView1.SmallImageList = this.imgSmallIcon;
			this.listView1.Sorting = System.Windows.Forms.SortOrder.Descending;
			this.listView1.TabIndex = 3;
			this.listView1.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.listView1_OnColumnClick);
			this.listView1.SelectedIndexChanged += new System.EventHandler(this.listView1_OnSelectedIndexChanged);
			// 
			// lvcState
			// 
			this.lvcState.Text = "State Name";
			this.lvcState.Width = 120;
			// 
			// lvcCapital
			// 
			this.lvcCapital.Text = "Capital City";
			this.lvcCapital.Width = 120;
			// 
			// imgLargeIcon
			// 
			this.imgLargeIcon.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imgLargeIcon.ImageSize = new System.Drawing.Size(48, 32);
			this.imgLargeIcon.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgLargeIcon.ImageStream")));
			this.imgLargeIcon.TransparentColor = System.Drawing.Color.Teal;
			// 
			// imgSmallIcon
			// 
			this.imgSmallIcon.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imgSmallIcon.ImageSize = new System.Drawing.Size(24, 16);
			this.imgSmallIcon.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgSmallIcon.ImageStream")));
			this.imgSmallIcon.TransparentColor = System.Drawing.Color.Teal;
			// 
			// label1
			// 
			this.label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.label1.Location = new System.Drawing.Point(8, 200);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(280, 32);
			this.label1.TabIndex = 2;
			// 
			// imgToolbar
			// 
			this.imgToolbar.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imgToolbar.ImageSize = new System.Drawing.Size(16, 16);
			this.imgToolbar.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgToolbar.ImageStream")));
			this.imgToolbar.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// tbLargeIcon
			// 
			this.tbLargeIcon.ImageIndex = 0;
			this.tbLargeIcon.Pushed = true;
			this.tbLargeIcon.Text = "Large Icon";
			this.tbLargeIcon.ToolTipText = "Display items with large icons";
			// 
			// toolBar1
			// 
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.tbLargeIcon,
																						this.tbSmallIcon,
																						this.tbList,
																						this.tbReport});
			this.toolBar1.ButtonSize = new System.Drawing.Size(16, 16);
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imgToolbar;
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(292, 25);
			this.toolBar1.TabIndex = 1;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(104, 240);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(80, 24);
			this.button1.TabIndex = 0;
			this.button1.Text = "Close";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.listView1,
																		  this.label1,
																		  this.toolBar1,
																		  this.button1});
			this.MinimumSize = new System.Drawing.Size(300, 300);
			this.Name = "Form1";
			this.Text = "The State Flags";
			this.Resize += new System.EventHandler(this.Form1_OnResize);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
//
// Process a button click on the toolbar.
		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
// Put all buttons in the raised state. You don't know which
// button was down prior to this event unless you save it in
// an instance variable.
			for (int x = 0; x < 4; ++x)
			{
				toolBar1.Buttons[x].Pushed = false;
			}
// Put the button that was just pressed into a down state.
			toolBar1.Buttons[e.Button.ImageIndex].Pushed = true;
//
// Use the image index to determine which button was pressed, then
// set the ListView's View property to that state.
			switch (e.Button.ImageIndex)
			{
				case 0:
					listView1.View = View.LargeIcon;
					break;
				case 1:
					listView1.View = View.SmallIcon;
					break;
				case 2:
					listView1.View = View.List;
					break;
// For the report view, clear the sorting variables.
				case 3:
					listView1.View = View.Details;
					if (listView1.Sorting == SortOrder.None)
						listView1.Sorting = SortOrder.Ascending;
					else
						listView1.Sorting = SortOrder.None;
					break;
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			Application.Exit ();
		}
//
// Manually resize and reposition the controls on the form when the
// user changes the form size. The docking properties are not reliable.
		private void Form1_OnResize(object sender, System.EventArgs e)
		{
			if (!(sender is Form1))
				return;
//
// The movement of the button will determine positions
// for the other controls.
			int btnTop = button1.Bounds.Y;
//
// Reposition the button at the bottom.
			Rectangle rcButton = button1.Bounds;
			rcButton.X = (this.Bounds.Width - rcButton.Width) / 2;
			rcButton.Y = this.Bounds.Height - 5 * button1.Bounds.Height / 2;
			button1.Bounds = rcButton;
			int cy = button1.Bounds.Y - btnTop;
//
// Reposition and resize the Label control.
			Rectangle rcText;
			rcText = label1.Bounds;
			rcText.Y += cy;
			rcText.Height = label1.Bounds.Height;
			rcText.Width = this.Bounds.Width - 2 * rcText.Left - 8;
			label1.Bounds = rcText;
//
// Resize the ListView control.. The upper left will not change.
			Rectangle rcView;
			rcView = listView1.Bounds;
			rcView.Width = this.Bounds.Width - 2 * rcView.Left - 8;
			rcView.Height += cy;
			listView1.Bounds = rcView;
		}
//
// Process the column click event. This will happen only in report (details) mode.
		private void listView1_OnColumnClick(object sender, System.Windows.Forms.ColumnClickEventArgs e)
		{
// Make sure the sorter is valid;
			if (!(listView1.ListViewItemSorter is clsSort))
				return;
// Extract the sorter and recast it to clsSort.
			clsSort Sorter = (clsSort) listView1.ListViewItemSorter;
// If this click was on the same column as the last one, reverse the
// sort order by setting the property in clsSort.
			if (Sorter.LastSort == e.Column)
			{
				if (listView1.Sorting == SortOrder.Ascending)
					listView1.Sorting = SortOrder.Descending;
				else
					listView1.Sorting = SortOrder.Ascending;
			}
			else
				listView1.Sorting = SortOrder.Descending;
// Save the column that was clicked.
			Sorter.ByColumn = e.Column;
// And tell the control to re-sort.
			listView1.Sort ();
		}
//
// Use the SelectedIndexChanged event to read the item's information
// and display it in the label control.
		private void listView1_OnSelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (listView1.SelectedItems.Count == 0)
			{
				label1.Text = "";
				return;
			}
// Retrieve the text from the ListView control.
			string State = listView1.SelectedItems[0].SubItems[0].Text;
			string Capital = listView1.SelectedItems[0].SubItems[1].Text;
// Display the text in the label control.
			if (State.Length > 0)
			{
				label1.Text = "The capital of " + State + " is " + Capital;
			}
		}
	}
}
