// ObjEvent.cs -- Demonstrate passing an object to an event handler and
//                performing the proper cast in the method.
//
//                Compile this program with the following command line:
//                    C:>csc ObjEvent.cs
using System;

namespace nsEvents
{
    class clsMain
    {
        public delegate void EventHandler (object obj);
        public event EventHandler EvInvoke;

        public void FireEvent (object obj)
        {
            if (obj != null)
                EvInvoke (obj);
        }

        static public void Main ()
        {
            clsMain main = new clsMain ();
            main.EvInvoke = new clsMain.EventHandler (ObjEvent);
            main.FireEvent (42);
            main.FireEvent (42.0);
        }
        static void ObjEvent (object obj)
        {
            if (obj is double)
            {
                Console.WriteLine ("Received a double object: " + (double) obj);
            }
            else if (obj is int)
            {
                Console.WriteLine ("Received an int object: " + (int) obj);
            }
        }
    }
}
