namespace nsCircle
{
    using System;
    class clsMain
    {
        static public int Main (string [] args)
        {
            int angle;
            int radius = 100;
            try
            {
                angle = int.Parse (args[0]);
            }
            catch (IndexOutOfRangeException)
            {
                Console.WriteLine ("usage: circle [angle in degrees]");
                return (-1);
            }
            catch (FormatException)
            {
                Console.WriteLine ("Please use a number value for the angle in degrees");
                return (-1);
            }
            int cx = 0;
            int cy = 0;
            double Area = Circle (angle, radius, ref cx, ref cy);
// Alternate code using out variables
//            int cx, cy;
//            double Area = Circle (angle, radius, out cx, out cy);
            Console.WriteLine ("The point on the circle is at ({0}, {1})", cx, cy);
            Console.WriteLine ("The area of the circle is {0,0:F3}", Area);
            return (0);
        }

        static public double Circle (int angle, int radius, ref int cx, ref int cy)
// Alternate declaration using out parameters
//      static public double Circle (int angle, int radius, out int cx, out int cy)
        {
            const double radian = 57.29578;
// Convert the angle to radians
            double fAngle = (double) angle / radian;
// Compute the x position of the point
            cx = (int)((double) radius * Math.Cos (fAngle) + 0.5);
// Compute the y position of the point
            cy = (int)((double) radius * Math.Sin (fAngle) + 0.5);
//  Compute the area of the pie section
            return ((double) radius * (double) radius * fAngle / 2.0);
        }
    }
}