// ReadIn.cs -- Demonstrates using an OpenFileDialog to prompt for a
//              file name, and to open a file
//
//              Compile this program with the following command line:
//                  C:>csc ReadIn.cs
using System;
using System.IO;
using System.Windows.Forms;

namespace nsStreams
{
    class clsMain
    {
        static public void Main (string [] args)
        {
            OpenFileDialog fileOpen = new OpenFileDialog ();
            if (args.Length == 0)
            {
                fileOpen.InitialDirectory = ".\\";
                fileOpen.Filter = "Text files (*.txt)|*.txt|All files (*.*)|*.*";
                fileOpen.FilterIndex = 0;
                fileOpen.RestoreDirectory = false; //true;
//                if (fileOpen.ShowDialog () == DialogResult.Cancel)
                if (fileOpen.ShowDialog () != DialogResult.OK)
                {
                    return;
                }
            }
            else
            {
                fileOpen.FileName = args[0];
            }
            Stream strm;
            StreamReader reader;
            try
            {
                strm = fileOpen.OpenFile ();
                reader = new StreamReader (strm);
            }
            catch (Exception e)
            {
                string Message = e.Message + "\n\nCannot open "
                                 + fileOpen.FileName;
                MessageBox.Show (Message, "Open error",
                                 MessageBoxButtons.OK,
                                 MessageBoxIcon.Error);
                return;
            }
            Console.Write (reader.ReadToEnd ());
            reader.Close ();
            strm.Close ();
        }
    }
}
