/*
    Refs.cs -- demonstates that reference-type variable actually is a value-type
               variable that contains a reference. Show the difference between a
               reference-type variable and a reference parameter.

            Compile this program with the following
            command line:
                csc refs.cs
 */

namespace nsReferences
{
    using System;
    class clsMain
    {

       static void Main ()
        {
            clsFirst first = new clsFirst (21);
            Console.WriteLine ("Before function call, first.Variable = " + first.Variable);
            ShowValue (first);
            Console.WriteLine ("After function call, first.Variable = " + first.Variable);

// Now do the same thing except pass it to a function that uses a reference parameter.
            Console.WriteLine ("\n\nBefore function call, first.Variable = " + first.Variable);
            ShowReference (ref first);
            Console.WriteLine ("After function call, first.Variable = " + first.Variable);
        }

        static public void ShowValue (clsFirst var)
        {
            Console.WriteLine ("In function, var.Variable = " + var.Variable);
            var = new clsFirst (42);
            Console.WriteLine ("The new value for var.Variable = " + var.Variable);
        }
        static public void ShowReference (ref clsFirst var)
        {
            Console.WriteLine ("In function, var.Variable = " + var.Variable);
            var = new clsFirst (42);
            Console.WriteLine ("The new value for var.Variable = " + var.Variable);
        }
    }

    class clsFirst
    {
        public clsFirst (int var)
        {
            m_Var = var;
        }
        public int Variable
        {
            get
            {
                return (m_Var);
            }
            set
            {
                m_Var = value;
            }
         }
         private int m_Var;
    }
}
