//
// Static.cs -- Demonstrates how a static field is shared by
//              multiple instances of a class.
//
//              Compile this program with the following command line:
//                  C:>csc Static.cs
//
namespace nsStatic
{
    using System;
    class clsMain
    {
        static public void Main ()
        {
            for (int i = 0; i < 20; ++i)
            {
                clsStatic inst = new clsStatic();
            }
            Console.WriteLine ("Created {0} instance of clsStatic",
                               clsStatic.Count);
        }
    }
    class clsStatic
    {
        static public int Count
        {
            get {return (m_Count);}
        }
        static private int m_Count = 0;
        public clsStatic ()
        {
            ++m_Count;
        }
    }
}
