// Status.cs -- Uses methods in the File class to check the status of a file.
//
//              Compile this program with the following command line
//                  C:>csc Status.cs
using System;
using System.IO;

namespace nsStreams
{
    class clsMain
    {
        static public void Main (string [] args)
        {
            if (args.Length == 0)
            {
                Console.WriteLine ("Please enter a file name");
                return;
            }
            if (!File.Exists (args[0]))
            {
                Console.WriteLine (args[0] + " does not exist");
                return;
            }
            DateTime created = File.GetCreationTime (args[0]);
            DateTime accessed = File.GetLastAccessTime (args[0]);
            DateTime written = File.GetLastWriteTime (args[0]);
            Console.WriteLine ("File " + args[0] + ":");
            string str = created.ToString();
            int index = str.IndexOf (" ");
            Console.WriteLine ("\tCreated on " + str.Substring (0, index) + " at " + str.Substring (index + 1));
            str = accessed.ToString();
            index = str.IndexOf (" ");
            Console.WriteLine ("\tLast accessed on " + str.Substring (0, index) + " at " + str.Substring (index + 1));
            str = written.ToString();
            index = str.IndexOf (" ");
            Console.WriteLine ("\tLast written on " + str.Substring (0, index) + " at " + str.Substring (index + 1));
        }
    }
}
