using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Text;
//using System.Threading;

namespace Tree
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.TreeView treeView1;
		private System.Windows.Forms.Label label1;

		delegate void InvokePopulate ();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			PopulateTree ();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.button2 = new System.Windows.Forms.Button();
			this.treeView1 = new System.Windows.Forms.TreeView();
			this.SuspendLayout();
			// 
			// imageList1
			// 
			this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(57, 272);
			this.button1.Name = "button1";
			this.button1.TabIndex = 1;
			this.button1.Text = "OK";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 232);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(280, 32);
			this.label1.TabIndex = 3;
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(161, 272);
			this.button2.Name = "button2";
			this.button2.TabIndex = 2;
			this.button2.Text = "Cancel";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// treeView1
			// 
			this.treeView1.ImageList = this.imageList1;
			this.treeView1.Location = new System.Drawing.Point(5, 8);
			this.treeView1.Name = "treeView1";
			this.treeView1.Size = new System.Drawing.Size(280, 216);
			this.treeView1.TabIndex = 0;
			this.treeView1.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeView1_AfterSelect);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(294, 303);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.button2,
																		  this.button1,
																		  this.treeView1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "Form1";
			this.Text = "Choose Directory";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
//
// Initializes and populates the TreeView control.
		protected void PopulateTree()
		{
			TreeNode tnRootNode;
// Clear any residual nodes from the tree. You do not have
// to do this for a new tree, but if you want to add a refresh
// button later you will need to do this.
			treeView1.Nodes.Clear();
// Get the machine name from the Environment class. This will
// be the root node.
			tnRootNode = new TreeNode(Environment.MachineName, 2, 2);
			treeView1.Nodes.Add(tnRootNode);
// Get the node collection for the root node. The drives will be
// added to this node.
			TreeNodeCollection tncDrives =  tnRootNode.Nodes;

// Get the logical drives from the Environment class
			string[] strLogicalDrives = Environment.GetLogicalDrives();
			string strCurrentDrive = "";
// Add the drives to the machine name node.			
			foreach (object obj in strLogicalDrives) 
			{
				strCurrentDrive = (string) obj;
// Create a root node for the drive. use a different image
// for the floppy and hard drives.
				if (strCurrentDrive == "A:\\") 
				{
					TreeNode tnDriveNode = new TreeNode(strCurrentDrive, 3, 3);
					tncDrives.Add(tnDriveNode);
					continue;
				}
				else 
				{
// Add the directories on this drive. First create a node object
					TreeNode tnDriveNode = new TreeNode(strCurrentDrive);
// Get the directory info for the current drive.
					DirectoryInfo d = new DirectoryInfo (strCurrentDrive);
// Add the directories to the node.
					ShowDirectories(d, tncDrives, 4, 4);
				}
			}
// Expand the root node to show the drives.
			tnRootNode.Expand ();
		}
//
// Recursively adds directories to the tree.
		public void ShowDirectories (DirectoryInfo d, TreeNodeCollection tncCollection, int iImageIndex, int iSelectedImage)
		{
// Create a node for this entry
			TreeNode tnCurNode = new TreeNode(d.Name, iImageIndex, iSelectedImage);
// Add the new node to the current node (passed as an argument).
			tncCollection.Add(tnCurNode);
// Get the subdirectories for this directory and call this
// method recursively to add the nodes. If a CD or DVD drive is
// empty, the CLR will throw an exception. Catch and it return.
			DirectoryInfo [] dirs;
			try
			{
/* An unhandled exception of type 'System.InvalidOperationException' occurred in system.windows.forms.dll
Additional information: The action being performed on this 
control is being called from the wrong thread. You must marshal
to the correct thread using Control.Invoke or 
Control.BeginInvoke to perform this action. */
				dirs = d.GetDirectories ();
			}
			catch (Exception)
			{
				return;
			}
			
			foreach (DirectoryInfo dir in dirs)
			{
				try
				{
// Call this method passing the node collection as an argument.
					ShowDirectories (dir, tnCurNode.Nodes, 0, 1);
				}
// If we cannot access this directory, just pass on it.
				catch (UnauthorizedAccessException)
				{
					continue;
				}
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
// Copy the result to the clipboard
// If used as a choose directory form, use label1.Text
// to retrieve the selected directory instead of the
// clipboard.
			Clipboard.SetDataObject (label1.Text, true);
			Application.Exit ();
// Use the following line if this is a form inside another application
//			Close ();
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			Application.Exit ();
// Use the following line if this is a form inside another application
//			Close ();
		}

		private void treeView1_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			StringBuilder str = new StringBuilder();
			str.Insert (0, treeView1.SelectedNode.Text);
			TreeNode tcNode = treeView1.SelectedNode;
			while ((tcNode = tcNode.Parent) != null)
			{
				if (tcNode.Text.IndexOf ('\\') >= 0)
				{
					string temp = tcNode.Text;
					int index = temp.IndexOf ('\\');
					temp.Remove (index, 1);
					str.Insert (0, temp);
					continue;
				}
				if (tcNode.Text == Environment.MachineName)
					break;
				str.Insert (0, tcNode.Text + "\\");
			}
			label1.Text = str.ToString();
		}
	}
}
