// WriteOut.cs -- Writes the same string to a file and to the screen using
//                a common method.
//
//                Compile this program with the following command line:
//                    C:>csc WriteOut.cs
namespace nsStreams
{
    using System;
// When using streams, you must declare that you are using System.IO
    using System.IO;
    class clsMain
    {
        static public void Main ()
        {
            string str = "This is a line of text\r\n";
// Open the standard output stream
            Stream ostrm = Console.OpenStandardOutput ();
// Open a file. You should protect an open in a try ... catch block
            FileStream fstrm;
            try
            {
                fstrm = new FileStream ("./OutFile.txt", FileMode.OpenOrCreate);
            }
            catch
            {
                Console.WriteLine ("Failed to open file");
                return;
            }
// Call WriteToStream() to write the same string to both
            WriteToStream (ostrm, str);
            WriteToStream (fstrm, str);
// Close the file.
            fstrm.Close ();
            ostrm.Close ();
        }
        static public void WriteToStream (Stream strm, string text)
        {
            foreach (char ch in text)
            {
                strm.WriteByte ((Byte) ch);
            }
// Flush the output to make it write
            strm.Flush ();
        }
    }
}
